/*

 DC Receiver special ADC driver

 OH2NLT 13.01.2004
 
 A/D converter must be kept closed when not operating.
 This approach frees few digital I/O bits for use.

 Code size optimization 18.01.2005
 16F88 conversion added 28.08.2005

*/


//*****************************************
// Convert one chanel returns integer value
// chnum selects chanell
//*****************************************

// start conversion & return with result

void convert_adc(void)
{
	delayu(250);
	GODONE = 1;
	asm("nop");
	while (GODONE)
		;
}


// set up A/D converter, measure CH0 & CH1
// free digital I/O's after operation

void measure_all(void)
	{
#ifdef F88
	ANSEL = ANSEL_MEAS;					// Select configure F88 I/O
#else
	ADCON1 = ADCON1_MEAS;				// Select mode & configure I/O
#endif
	ADCON0 = ADCON0_CH0;				// select Ch0 & turn A/D system on
	convert_adc();
	ad.adcregs[0]=ADRESL;				// save battery voltage
	ad.adcregs[1]=ADRESH;

	ADCON0 = ADCON0_CH1;				// select Ch0 & turn A/D system on
	convert_adc();
	smeter = ADRESL;					// save S-meter data. Only LSB is used.

	ADCON0 = ADCON0_OFF;				// shut down A/D system
#ifdef F88
	ANSEL = ANSEL_INIT;					// PORTA pins digital I/O
#else
	ADCON1 = ADCON1_INIT;				// PORTA pins digital I/O
#endif
	}
